//
//  SLMikeInputView.m
//  SLAiELTS
//
//  Created by Gusont on 2023/3/3.
//

#import "SLMikeInputView.h"
#import "SLMessageViewController.h"
@interface SLMikeInputView()

@property (weak, nonatomic) IBOutlet NSLayoutConstraint *imgHeightConst;
@property (weak, nonatomic) IBOutlet UIImageView *mikeDhBg;

@end

@implementation SLMikeInputView

- (instancetype)initWithCoder:(NSCoder *)aDecoder {
    self = [super initWithCoder:aDecoder];
    if (self) {
        [self addContentView];
    }
    return self;
}
- (instancetype)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self addContentView];
    }
    return self;
}

- (void)addContentView {
    [[NSBundle mainBundle] loadNibNamed:@"SLMikeInputView" owner:self options:nil];
    self.contentView.frame = self.bounds;
    [self addSubview:self.contentView];
    self.contentView.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.55];
    UILongPressGestureRecognizer *gesture=[[UILongPressGestureRecognizer alloc]initWithTarget:self action:@selector(handleLongPressGestures:)];
    gesture.minimumPressDuration= 0.3f;
    [self addGestureRecognizer:gesture];
//    gesture.numberOfTouchesRequired = 1;
    UIImage *img = self.mikeInputImageView.image;
    [img resizableImageWithCapInsets:UIEdgeInsetsMake(90, 0, 0, 0) resizingMode:UIImageResizingModeStretch];
    self.mikeInputImageView.image = img;
    CGFloat h = 110 + kSafeAreaBottom;
    self.imgHeightConst.constant = h;
    self.clipsToBounds = YES;
    self.contentView.hidden = YES;
    [self nuiSpeechRecognizer];
    
    WS(weakSelf);
    __block CGFloat bSendTime = 0.0;
    self.nuiSpeechRecognizer.onVolumeChangedBlock = ^(CGFloat volume) {
        CGFloat sendTime = [[NSDate date] timeIntervalSince1970];
        if (sendTime * 1000 - bSendTime > 160) {
            bSendTime = sendTime * 1000;
            NSInteger v = 0;
            if (volume + 160 < 90) {
                v = (volume + 160) / 6;
                dispatch_async(dispatch_get_main_queue(), ^{
                    weakSelf.mikeTipImageView.image = [UIImage imageNamed:[NSString stringWithFormat:@"音波_000%02ld.png",v + 1]];
                });
//                NSLog(@"===%ld==%f-%@---%f",v,volume,[NSString stringWithFormat:@"音波_000%02ld",v],sendTime);

            }else {
                v = (volume + 70) / 7;
                dispatch_async(dispatch_get_main_queue(), ^{
                    weakSelf.mikeTipImageView.image = [UIImage imageNamed:[NSString stringWithFormat:@"音波 3_000%02ld.png",v + 1]];
                });
//                NSLog(@"===%ld==%f-%@---%f",v,volume,[NSString stringWithFormat:@"音波 3_000%02ld",v],sendTime);

            }
    //        NSInteger v = MIN(36, (volume + 160) / 4);
            
        }
    };
}

- (void)handleLongPressGestures:(UILongPressGestureRecognizer *)paramSender {
    CGPoint point = [paramSender locationInView:paramSender.view];
    UIBezierPath *inputViewPath = [UIBezierPath bezierPathWithRect:self.mikeInputImageView.frame];
    if (CGPathContainsPoint(inputViewPath.CGPath, NULL, point, NO)) {
        
    }else{
    }
    UIBezierPath *cancelViewPath = [UIBezierPath bezierPathWithRect:self.mikeCancelImageView.frame];
    BOOL isContainCancelPath = CGPathContainsPoint(cancelViewPath.CGPath, NULL, point, NO);
    if (isContainCancelPath) {
        self.mikeCancelImageView.image = ImageName(@"icon_mike_cancel_sel");
        self.mikeInputImageView.image = ImageName(@"icon_mike_input_bg_sel");
        self.mikeDhBg.image = ImageName(@"icon_mike_dh_bg_sel");
        self.mikeLabel.text = @"松开 取消";
        if (paramSender.state == UIGestureRecognizerStateEnded){
            self.contentView.hidden = YES;
            self.frame = self.oldRect;
        }
    }else{
        self.mikeLabel.text = @"松开 发送";
        self.mikeDhBg.image = ImageName(@"icon_mike_dh_bg");
        self.mikeInputImageView.image = ImageName(@"icon_mike_input_bg");
        self.mikeCancelImageView.image = ImageName(@"icon_mike_cancel_nor");
    }
    if (paramSender.state == UIGestureRecognizerStateBegan) {
        self.frame = CGRectMake(0, 0, kSCREEN_WIDTH, kSCREEN_HEIGHT);
        self.contentView.hidden = NO;
        NSLog(@"SLMikeInputView long pressTap state :begin");
        [self.nuiSpeechRecognizer startSpeechRecognizer];
        UIImpactFeedbackGenerator *generator = [[UIImpactFeedbackGenerator alloc] initWithStyle:UIImpactFeedbackStyleHeavy];
        [generator impactOccurred];
        SLMessageViewController *vc = (SLMessageViewController *)self.viewController;
        if ([vc isKindOfClass:SLMessageViewController.class]) {
            UIView *view = [vc.view viewWithTag:SLImHintLabelTag];
            view.backgroundColor = [[UIColor grayColor] colorWithAlphaComponent:0.5];
        }
    }else if (paramSender.state == UIGestureRecognizerStateChanged){

    }else if (paramSender.state == UIGestureRecognizerStateEnded){
        NSLog(@"SLMikeInputView long pressTap state :ended");
        self.contentView.hidden = YES;
        self.frame = self.oldRect;
        [self.nuiSpeechRecognizer stopSpeechRecognizer:!isContainCancelPath];
        SLMessageViewController *vc = (SLMessageViewController *)self.viewController;
        if ([vc isKindOfClass:SLMessageViewController.class]) {
            [UIView animateWithDuration:1 animations:^{
                UIView *view = [vc.view viewWithTag:SLImHintLabelTag];
                view.backgroundColor = [UIColor whiteColor];
            }];
        }
    }else {
        NSLog(@"SLMikeInputView long pressTap state :end");
        [self.nuiSpeechRecognizer stopSpeechRecognizer:NO];
    }
}

- (SLNuiSpeechRecognizer *)nuiSpeechRecognizer {
    if (!_nuiSpeechRecognizer) {
        _nuiSpeechRecognizer = [[SLNuiSpeechRecognizer alloc] init];
    }
    return _nuiSpeechRecognizer;
}

- (void)alertShow {
    UIWindow* window = nil;
    if (@available(iOS 13.0, *)) {
        for (UIWindowScene* windowScene in [UIApplication sharedApplication].connectedScenes)
        {
            if (windowScene.activationState == UISceneActivationStateForegroundActive)
            {
                window = windowScene.windows.firstObject;
                break;
            }
        }
    }else {
        window = [[UIApplication sharedApplication].delegate window];
    }
    [window makeKeyAndVisible];
    [window makeKeyWindow];
    [window addSubview:self];
}

@end
